/** @noSelfInFile */
export declare class PriorityList<T> {
    list: {
        priority: number;
        member: T;
    }[];
    private presence;
    constructor();
    /**
     * Adds a member to this priority list
     * @param priority the priority of the member, lower means higher priority
     * @param member the member itself
     */
    put(priority: number, member: T): void;
    /**
     * Finds a member in the priority list
     * @param member The member to be found
     * @returns Position of the member
     */
    find(member: T): number;
    /**
     * Removes a member from the priority list
     * @param member The member to be removed
     */
    remove(member: T): void;
    /**
     * Checks if the member is in the priority list
     * @param member
     * @returns True if it's present, false if not
     */
    isPresent(member: T): boolean;
    /**
     * Removes and returns the member with the highest priority
     * @returns your highest priority member
     */
    take(): T;
    /**
     * Returns all the members to the pool
     */
    free(): void;
}
