--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
-- Lua Library inline imports
local function __TS__New(target, ...)
    local instance = setmetatable({}, target.prototype)
    instance:____constructor(...)
    return instance
end

local function __TS__Class(self)
    local c = {prototype = {}}
    c.prototype.__index = c.prototype
    c.prototype.constructor = c
    return c
end

local ____exports = {}
local ____lua_2Dbin_2Dsearch = require("lua-bin-search")
local binarySearch = ____lua_2Dbin_2Dsearch.binarySearch
local ____lua_2Dobject_2Dpool = require("lua-object-pool")
local ObjectPool = ____lua_2Dobject_2Dpool.ObjectPool
local ____fastRemove = require("fastRemove")
local fastRemove = ____fastRemove.fastRemove
local function ListMemberReset(self, o)
    o.member = 0
    o.priority = 0
end
local function ListMemberFactory(self)
    return {priority = 0, member = 0}
end
local priorityPool = __TS__New(
    ObjectPool,
    50,
    200,
    ListMemberFactory,
    ListMemberReset
)
____exports.PriorityList = __TS__Class()
local PriorityList = ____exports.PriorityList
PriorityList.name = "PriorityList"
function PriorityList.prototype.____constructor(self)
    self.list = {}
    self.presence = {}
end
function PriorityList.prototype.put(self, priority, member)
    self.presence[member] = true
    local listM = priorityPool:take()
    listM.member = member
    listM.priority = priority
    if #self.list < 1 then
        table.insert(self.list, listM)
    elseif #self.list < 2 then
        if self.list[1].priority > priority then
            table.insert(self.list, 2, listM)
        else
            table.insert(self.list, 1, listM)
        end
    elseif #self.list >= 2 then
        local insertIndex = binarySearch:findInsert(self.list, "priority", priority)
        table.insert(self.list, insertIndex, listM)
    end
end
function PriorityList.prototype.find(self, member)
    for i = 1, #self.list do
        if self.list[i].member == member then
            return i
        end
    end
    return 1
end
function PriorityList.prototype.remove(self, member)
    local i = self:find(member)
    local lm = fastRemove(self.list, i)
    self.presence[member] = nil
    local ____ = lm and priorityPool:free(lm)
end
function PriorityList.prototype.isPresent(self, member)
    return self.presence[member] ~= nil
end
function PriorityList.prototype.take(self)
    local c = self.list[#self.list].member
    self.presence[c] = nil
    local lm = table.remove(self.list)
    local ____ = lm and priorityPool:free(lm)
    return c
end
function PriorityList.prototype.free(self)
    for i = 1, #self.list do
        local o = self.list[i]
        priorityPool:free(o)
    end
end
return ____exports
